import type { Deck, Viewport, Widget, WidgetPlacement } from '@deck.gl/core';
interface CompassWidgetProps {
    id: string;
    placement?: WidgetPlacement;
    /**
     * View to attach to and interact with. Required when using multiple views.
     */
    viewId?: string | null;
    /**
     * Tooltip message.
     */
    label?: string;
    /**
     * Bearing and pitch reset transition duration in ms.
     */
    transitionDuration?: number;
    /**
     * CSS inline style overrides.
     */
    style?: Partial<CSSStyleDeclaration>;
    /**
     * Additional CSS class.
     */
    className?: string;
}
export declare class CompassWidget implements Widget<CompassWidgetProps> {
    id: string;
    props: CompassWidgetProps;
    placement: WidgetPlacement;
    viewId?: string | null;
    viewport?: Viewport;
    deck?: Deck<any>;
    element?: HTMLDivElement;
    constructor(props: CompassWidgetProps);
    setProps(props: Partial<CompassWidgetProps>): void;
    onViewportChange(viewport: any): void;
    onAdd({ deck }: {
        deck: Deck<any>;
    }): HTMLDivElement;
    getRotation(): number[];
    update(): void;
    onRemove(): void;
    handleCompassReset(): void;
}
export {};
//# sourceMappingURL=compass-widget.d.ts.map