import type { Deck, Viewport, Widget, WidgetPlacement } from '@deck.gl/core';
interface ZoomWidgetProps {
    id: string;
    placement?: WidgetPlacement;
    /**
     * View to attach to and interact with. Required when using multiple views.
     */
    viewId?: string | null;
    /**
     * Button orientation.
     */
    orientation?: 'vertical' | 'horizontal';
    /**
     * Tooltip message on zoom in button.
     */
    zoomInLabel?: string;
    /**
     * Tooltip message on zoom out button.
     */
    zoomOutLabel?: string;
    /**
     * Zoom transition duration in ms.
     */
    transitionDuration?: number;
    /**
     * CSS inline style overrides.
     */
    style?: Partial<CSSStyleDeclaration>;
    /**
     * Additional CSS class.
     */
    className?: string;
}
export declare class ZoomWidget implements Widget<ZoomWidgetProps> {
    id: string;
    props: ZoomWidgetProps;
    placement: WidgetPlacement;
    orientation: 'vertical' | 'horizontal';
    viewId?: string | null;
    viewport?: Viewport;
    deck?: Deck<any>;
    element?: HTMLDivElement;
    constructor(props: ZoomWidgetProps);
    onAdd({ deck }: {
        deck: Deck<any>;
    }): HTMLDivElement;
    onRemove(): void;
    setProps(props: Partial<ZoomWidgetProps>): void;
    onViewportChange(viewport: any): void;
    handleZoom(nextZoom: number): void;
    handleZoomIn(): void;
    handleZoomOut(): void;
}
export {};
//# sourceMappingURL=zoom-widget.d.ts.map